Loading...
Searching...
No Matches
pcl::PPFHashMapSearch Class Reference

`#include <pcl/registration/ppf_registration.h>`

## Classes

struct | HashKeyStruct
| Data structure to hold the information for the key in the feature hash map of the PPFHashMapSearch class. More...

## Public Types

using | FeatureHashMapType = std::unordered_multimap< HashKeyStruct, std::pair< std::size_t, std::size_t >, HashKeyStruct >
using | FeatureHashMapTypePtr = shared_ptr< FeatureHashMapType >
using | Ptr = shared_ptr< PPFHashMapSearch >
using | ConstPtr = shared_ptr< const PPFHashMapSearch >

## Public Member Functions

| PPFHashMapSearch (float angle_discretization_step=12.0f/180.0f *static_cast< float >(M_PI), float distance_discretization_step=0.01f)
| Constructor for the PPFHashMapSearch class which sets the two step parameters for the enclosed data structure.
void | setInputFeatureCloud (PointCloud< PPFSignature >::ConstPtr feature_cloud)
| Method that sets the feature cloud to be inserted in the hash map.
void | nearestNeighborSearch (float &f1, float &f2, float &f3, float &f4, std::vector< std::pair< std::size_t, std::size_t > > &indices)
| Function for finding the nearest neighbors for the given feature inside the discretized hash map.
Ptr | makeShared ()
| Convenience method for returning a copy of the class instance as a shared_ptr.
float | getAngleDiscretizationStep () const
| Returns the angle discretization step parameter (the step value between each bin of the hash map for the angular values)
float | getDistanceDiscretizationStep () const
| Returns the distance discretization step parameter (the step value between each bin of the hash map for the distance values)
float | getModelDiameter () const
| Returns the maximum distance found between any feature pair in the given input feature cloud.

## Public Attributes

std::vector< std::vector< float > > | alpha_m_

## Detailed Description

Definition at line 49 of file ppf_registration.h.

## Member Typedef Documentation

## ConstPtr

using pcl::PPFHashMapSearch::ConstPtr = shared_ptr<const PPFHashMapSearch>

Definition at line 90 of file ppf_registration.h.

## FeatureHashMapType

using pcl::PPFHashMapSearch::FeatureHashMapType = std::unordered_multimap<HashKeyStruct, std::pair<std::size_t, std::size_t>, HashKeyStruct>

Definition at line 84 of file ppf_registration.h.

## FeatureHashMapTypePtr

using pcl::PPFHashMapSearch::FeatureHashMapTypePtr = shared_ptr<FeatureHashMapType>

Definition at line 88 of file ppf_registration.h.

## Ptr

using pcl::PPFHashMapSearch::Ptr = shared_ptr<PPFHashMapSearch>

Definition at line 89 of file ppf_registration.h.

## Constructor & Destructor Documentation

## PPFHashMapSearch()

pcl::PPFHashMapSearch::PPFHashMapSearch | ( | float | angle_discretization_step = `12.0f / 180.0f * static_cast<float>(M_PI)`,
|  | float | distance_discretization_step = `0.01f`
| ) |  |

inline

Constructor for the PPFHashMapSearch class which sets the two step parameters for the enclosed data structure.

Parameters

  angle_discretization_step | the step value between each bin of the hash map for the angular values
  distance_discretization_step | the step value between each bin of the hash map for the distance values

Definition at line 98 of file ppf_registration.h.

## Member Function Documentation

## getAngleDiscretizationStep()

float pcl::PPFHashMapSearch::getAngleDiscretizationStep | ( |  | ) | const

inline

Returns the angle discretization step parameter (the step value between each bin of the hash map for the angular values)

Definition at line 138 of file ppf_registration.h.

## getDistanceDiscretizationStep()

float pcl::PPFHashMapSearch::getDistanceDiscretizationStep | ( |  | ) | const

inline

Returns the distance discretization step parameter (the step value between each bin of the hash map for the distance values)

Definition at line 146 of file ppf_registration.h.

## getModelDiameter()

float pcl::PPFHashMapSearch::getModelDiameter | ( |  | ) | const

inline

Returns the maximum distance found between any feature pair in the given input feature cloud.

Definition at line 154 of file ppf_registration.h.

## makeShared()

Ptr pcl::PPFHashMapSearch::makeShared | ( |  | ) |

inline

Convenience method for returning a copy of the class instance as a shared_ptr.

Definition at line 130 of file ppf_registration.h.

## nearestNeighborSearch()

void pcl::PPFHashMapSearch::nearestNeighborSearch | ( | float & | f1,
|  | float & | f2,
|  | float & | f3,
|  | float & | f4,
|  | std::vector< std::pair< std::size_t, std::size_t > > & | indices
| ) |  |

Function for finding the nearest neighbors for the given feature inside the discretized hash map.

Parameters

  f1 | The 1st value describing the query PPFSignature feature
  f2 | The 2nd value describing the query PPFSignature feature
  f3 | The 3rd value describing the query PPFSignature feature
  f4 | The 4th value describing the query PPFSignature feature
  indices | a vector of pair indices representing the feature pairs that have been found in the bin corresponding to the query feature

## setInputFeatureCloud()

void pcl::PPFHashMapSearch::setInputFeatureCloud | ( | PointCloud< PPFSignature >::ConstPtr | feature_cloud | ) |

Method that sets the feature cloud to be inserted in the hash map.

Parameters

  feature_cloud | a const smart pointer to the PPFSignature feature cloud

## Member Data Documentation

## alpha_m_

std::vector<std::vector<float> > pcl::PPFHashMapSearch::alpha_m_

Definition at line 159 of file ppf_registration.h.

The documentation for this class was generated from the following file:

- pcl/registration/ppf_registration.h